# SPDX-FileCopyrightText: Copyright (c) 2023, Linaro Limited.
#
# SPDX-FileCopyrightText: <text>Copyright 2023 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT
---

{% set should_run = ('nightly' in FREQUENCY or 'weekly' in FREQUENCY or 'all' in FORCE_TESTS or 'ptest' in FORCE_TESTS.split(',')) %}

device_type: mps3
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
{% if should_run %}
    minutes: 650
{% else %}
    minutes: 280
{% endif %}
  actions:
    auto-login-action:
      minutes: 30
  connections:
    auto-login-action:
      minutes: 30
    login-action:
      minutes: 30

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/corstone1000-mps3/sanity_job.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

priority: medium
visibility:
  group:
    - cassini

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

context:
  boot_character_delay: 250
  test_character_delay: 250

actions:

- boot:
    namespace: uart0
    method: new_connection
    connection: uart0

- boot:
    namespace: uart1
    method: new_connection
    connection: uart1

- boot:
    namespace: uart3
    method: new_connection
    connection: uart3

# Booting the mps3 test suite
- deploy:
    to: flasher
    images:
      recovery_image:
        url: "{{ FIRMWARE_ARTIFACT }}"
    namespace: target
    timeout:
      minutes: 5

# Run kernel in Flash to copy rootfs overlay to USB stick
- boot:
    namespace: target
    method: u-boot
    timeout:
      minutes: 30
    commands:
      - run retrieve_kernel_load_addr
      - echo Loading kernel from $kernel_addr to memory ...
      - unzip $kernel_addr 0x90000000
      - loadm 0x90000000 $kernel_addr_r $filesize
      - bootefi $kernel_addr_r $fdtcontroladdr
    parameters:
      kernel-start-message: 'Linux version [0-9]'
    auto_login:
      login_prompt: 'corstone1000-mps3 login:.*'
      username: root
    prompts:
      - '@corstone1000-mps3:.+# '

#
# Fudge to enable bmap-tool usage
#
- deploy:
    namespace: poky
    timeout:
      minutes: 5
    to: usb
    os: oe
    images:
      image:
        url: "{{ UTIL_ARTIFACT }}"
        compression: bz2
    uniquify: false
    device: usb_storage_device
    download:
      tool: /usr/bin/wget
      options: --no-check-certificate -O - {DOWNLOAD_URL}
      prompt: "Connecting to .+"
    writer:
      tool: /bin/tar
      options: -C / -xf -
      prompt: 'writing to stdout'
    tool:
      prompts:
        - 'written to stdout'

#
# Deploy the cassini uefi image stored as artifacts by the build job
#
- deploy:
    namespace: secondary_media
    timeout:
      minutes: 150
    to: usb
    os: oe
    images:
      image:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
      bmap:
        url: "{{ BMAP_ARTIFACT }}"
    uniquify: false
    device: usb_storage_device
    writer:
      tool: /usr/bin/bmaptool
      options: copy {DOWNLOAD_URL} /dev/sda
      prompt: 'bmaptool: info'
    tool:
      prompts: ['copying time: [0-9hms\.\ ]+, copying speed [0-9\.]+ [MK]iB\/sec']

- boot:
    namespace: secondary_media
    method: minimal
    timeout:
      minutes: 40
    parameters:
      kernel-start-message: 'Linux version [0-9]'
    auto_login:
      login_prompt: 'corstone1000-mps3 login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
      - sudo su -
      - wait-online.sh eth0
    prompts:
      - 'Password: '
      - 'New password: '
      - 'Re-enter new password: '
      - '@corstone1000-mps3:.+\$ '
      - '@corstone1000-mps3:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

- test:
    namespace: secondary_media
    timeout:
{% if should_run %}
      minutes: 400
{% else %}
      minutes: 40
{% endif %}
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: cassini-integration-tests
            description: "Run Cassini integration tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 600 user-accounts-integration-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 600 container-engine-integration-tests"
{% if should_run %}
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 3600 psa-arch-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 18000 parsec-simple-e2e-tests"
{% endif %}
              - jfrog-cli config add --insecure-tls=true artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }};
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "/home/test/runtime-integration-tests-logs/",
                      "target": "oss-cassini.lava-images-temp/ptest-runner-results/",
                      "flat": "true",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="oss-cassini/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog-cli rt upload --insecure-tls=true --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog-cli rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory
              - jfrog-cli rt build-publish --insecure-tls=true "${build_name}" "{{ CI_JOB_ID }}" --build-url="{{ CI_PROJECT_URL }}"
              # Discard builds and artifacts previously published to Artifactory
              - jfrog-cli rt build-discard --insecure-tls=true "${build_name}" --max-builds=10 --delete-artifacts --async
        from: inline
        name: cassini-integration-tests
        path: inline/cassini-integration-tests.yaml

- test:
    namespace: secondary_media
    timeout:
      minutes: 2
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: dump_upload_log
            description: '"Output Upload log"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
            - cat /home/root/.jfrog/logs/jfrog-cli.*.log || true
        from: inline
        name: output-upload-log
        path: inline/output-upload-log.yaml
